module TypeHolder exposing (Model, Msg(..))
-- Http
import Http
-- Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import Manager.StateManager exposing (State)
import Manager.ModalManager exposing (Modal, ModalMsg)
import Util.ShapeManager exposing (Shape, ShapeStyle, ShapesMsg)
import Util.Util         exposing (MousePosition, Picture, ImgDimensions, QueryInfo, JsonFile)

type alias Model =
  { state : State
  , saved : List (Shape, ShapeStyle)
  , svgShapeHover : Int
  , httpLoadResult : (Result Http.Error String)
  , picture :  Maybe Picture
  , queryInfo : QueryInfo
  , jsonFile : JsonFile
  , url : Url.Url
  , key : Nav.Key
  }

type Msg
  -- Manage Objects
  = ManageModal  ModalMsg  String
  | ManageShapes ShapesMsg String
  -- svg
  | SvgShapeHover Int
  -- for drawing shapes
  | OpenDrawShape Shape
  | UpdateMousePos MousePosition
  | InputDrawShape
  -- for loading Strings with http
  | ShapePictureJsonStringLoaded (Result Http.Error String)
  -- Url
  | LinkClicked Browser.UrlRequest
  | UrlChanged Url.Url
  -- Json Decoder
  | DecodeJson String
  -- for saving pictureUrl
  | SavePicture Picture
  | ImgLoaded ImgDimensions
  -- for loading ShapePicture
  | LoadShapePicture String